︠33b4c40a-de52-432a-9249-396c08b6f2b6i︠
%md
A binary operation on $A$ is a function $f$ such that $f:A \times A \rightarrow A$.



︡d477b25b-f76a-4d43-a5e9-ccbd2a86966d︡︡{"done":true,"md":"A binary operation on $A$ is a function $f$ such that $f:A \\times A \\rightarrow A$."}
︠07515086-5e7a-44fa-9534-716456d198ebs︠
typeset_mode(True, display=False)

a,b,c,d, e, f = var('a b c d e f')

def ex_1_d(tup1=(a, b), tup2=(c,d)):
    return (tup1[0]*tup2[1]+tup1[1]*tup2[0], tup1[1]*tup2[1])

LHS = ex_1_d((a,b), ex_1_d((b,c), (e,f)))
print RHS == LHS
show (RHS)
show ("(", RHS[0].expand(),",", RHS[1].expand(), ")")
show ("(", LHS[0].expand(),",", LHS[1].expand() , ")")
︡292482eb-93fe-4053-a437-fd74a38273d3︡︡{"stdout":"True"}︡{"stdout":"\n"}︡{"html":"<div align='center'>($\\displaystyle b c e + {\\left(b^{2} + a c\\right)} f$, $\\displaystyle b c f$)</div>"}︡{"html":"<div align='center'>( $\\displaystyle b c e + b^{2} f + a c f$ , $\\displaystyle b c f$ )</div>"}︡{"html":"<div align='center'>( $\\displaystyle b c e + b^{2} f + a c f$ , $\\displaystyle b c f$ )</div>"}︡{"done":true}
︠a4d92fba-d4e8-4105-af17-567a59fab826s︠
def ex_1_b(a,b):
    return a + b + a*b
RHS = ex_1_b(ex_1_b(a,b),d)
LHS = ex_1_b(a, ex_1_b(b, d))
(RHS-LHS).expand()
︡c976b72b-df5b-45f0-9e56-10ca765c574b︡︡{"html":"<div>$0$</div>"}︡{"done":true}
︠123e569b-5754-48f2-8bd7-ab6cb60c7e5ds︠
def ex_1_c(a,b):
    return (a+b)/5
RHS = ex_1_c(ex_1_b(a,b),c)
LHS = ex_1_c(a, ex_1_b(b, c))
(RHS-LHS).expand()

︡68dbc8c8-9c22-4a7a-9ed7-1ddb294d8cd0︡︡{"html":"<div>$\\frac{1}{5} \\, a b - \\frac{1}{5} \\, b c$</div>"}︡{"done":true}
︠7d6d61a9-67d4-4ace-a03e-628c898d069cs︠
def ex_1_d(a,b):
    return a/b

RHS = ex_1_d(ex_1_d(a,b),d)
LHS = ex_1_d(a, ex_1_d(b, d))
RHS == LHS
︡628a1fe7-9d57-41b0-96b7-a1d47d4c071a︡︡{"html":"<div>$\\frac{a}{b d} = \\frac{a d}{b}$</div>"}︡{"done":true}
︠f06dc021-cf50-4c50-969f-65f5ebf851a5︠









